from Packet import *
from Marks import *


class IPSecAnalyzer:

    def analyze(self, packet):

        # detekce dat ipsecu
        if get_transport_protocol_from_packet(packet) == "ESP" or get_transport_protocol_from_packet(
                packet) == "AH":
            set_mark_on_packet(packet, Marks.IPSEC_DATA)
            return 1

        # detekce ike protokolu (navázání spojení ipsecu)
        if (get_dst_port_from_packet(packet) == 4500 or get_src_port_from_packet(packet) == 4500) and \
                get_protocol_ip_from_packet(packet) == 17:

            if len(packet.raw_data) < 5:
                return 0

            # IKEv2
            udp_encaps_ipsec = packet.raw_data[0] + packet.raw_data[1] + packet.raw_data[2] + \
                               packet.raw_data[3]

            if udp_encaps_ipsec == 0:
                temp = hex(packet.raw_data[21])
                info = hex(packet.raw_data[22])
            else:
                temp = hex(packet.raw_data[13])
                info = hex(packet.raw_data[14])
            if len(packet.raw_data) > 0 and temp == '0x20' and \
                    (info == '0x22' or info == '0x23' or info == '0x24' or info == '0x25'):
                packet.transport_protocol = "ISAKMP"
                set_mark_on_packet(packet, Marks.IPSEC_CONTROL)
                return 1
            else:
                set_mark_on_packet(packet, Marks.IPSEC_DATA)
                return 1
        if (get_dst_port_from_packet(packet) == 500 or get_src_port_from_packet(packet) == 500) and \
                get_protocol_ip_from_packet(packet) == 17:
            # IKEv1
            udp_encaps_ipsec = packet.raw_data[0] + packet.raw_data[1] + packet.raw_data[2] + \
                               packet.raw_data[3]
            if udp_encaps_ipsec == 0:
                temp = hex(packet.raw_data[25])
                info = hex(packet.raw_data[26])
            else:
                temp = hex(packet.raw_data[17])
                info = hex(packet.raw_data[18])
            if len(packet.raw_data) > 0 and temp == '0x10' and (info == '0x5' or info == '0x20'):
                packet.transport_protocol = "ISAKMP"
                set_mark_on_packet(packet, Marks.IPSEC_CONTROL)
                return 1
            else:
                set_mark_on_packet(packet, Marks.IPSEC_DATA)
                return 1
        return 0

    def filter_false_positives(self, ip_addresses):
        intersect = set(ip_addresses[Marks.IPSEC_DATA].keys()).intersection(
            set(ip_addresses[Marks.IPSEC_CONTROL].keys()))
        for address in list(ip_addresses[Marks.IPSEC_DATA].keys()):
            if address not in intersect:
                del ip_addresses[Marks.IPSEC_DATA][address]

        for address in list(ip_addresses[Marks.IPSEC_CONTROL].keys()):
            if address not in intersect:
                del ip_addresses[Marks.IPSEC_CONTROL][address]
